; Смешной козодоевский загрузчик FAT16
use16
org 0x7c00

jmp short main ; волшебные три байта, предотвращающие попытку исполнения BPB как код
nop

OEMid: db "PIZDEC  "
bytesPerSect: dw 512
secsPerCluster: db 4
resSecs: dw 1
FATs: db 2
rootDirEntr: dw 224
secs: dw 65535
mediaDescType: db 0xf8
secsPerFAT: dw 128
secsPerTrack: dw 32
heads: dw 64
hiddenSecs: dd 0
largeSecsCount: dd 0

driveNum: db 0x80
NTFlags: db 0
sign: db 0x28
volumeID: dd 0x22801337
volumeLabel: db "PIZDEC     "
fsType: db "FAT16   "

bootdev: db 0
firstdatasect: dw 0

main:
	mov si,welcome_msg
	call print
	mov [bootdev],dl
	;Загружаем FAT
	mov cx,[secsPerFAT]
	mov ax,[resSecs]
	mov bx,0x8000
	call readsect

	;Считаем первый сектор данных
	mov ax,32
	mul word [rootDirEntr]
	div word [bytesPerSect]
	add ax,[resSecs]
	xchg ax,cx
	mov ax,word [FATs]
	mul word [secsPerFAT]
	add ax, cx
	mov [firstdatasect],ax

	xor eax,eax
	;Загружаем корневой каталог
	mov al,byte [FATs]
	mul word [secsPerFAT]
	add ax,word [resSecs]
	mov cx,1
	mov bx,0x9000
	call readsect

	xor ax,ax
	xor cx,cx
	xor bx,bx
	mov bx,0x9000
	.next: ;Ищем файл
		mov al,[bx]
		cmp al,0
		je stop
		mov si,kernel_name
		mov di,bx
		mov cx,8
		rep cmpsb
		jne .no
		mov ax,word [bx+26]
		;mov cx,word [firstdatasect]
		;Загружаем сам файл
		mov bx,0x1000
		jmp fetch
		.no:
			add bx,32
			jmp .next

	jmp $

stop: ; не нашли
	mov ah,0eh
	mov al,"E"
	int 10h
	jmp $
fetch:
	push ax
	call calculatesect
	xor cx,cx
	mov cl,[secsPerCluster]
	call readsect
	pop ax
	push bx
	mov bx,0x8000
	mov cx,ax
	shl cx,1
	add bx,cx
	mov ax,word [bx]
	pop bx
	cmp ax,0xffff
	je end
	add bx,2048
	jmp fetch
end:
	pop bx
	mov si,boot_msg
	call print
	xor eax,eax
	xor ebx,ebx
	xor ecx,ecx
	xor edx,edx
	jmp 0x0:0x1000
badclust:
	pop bx
	jmp $

;readsect	
;ВХОД: eax=LBA
;      es:bx=куда загружать данные
;	   cx=кол-во секторов
;ВЫХОД: нету :)

readsect:
	pusha
	mov di,sp
	push byte 0
	push byte 0
	push eax
	push es
	push bx
	push word cx
	push byte 16
	mov si,sp
	mov dl,[bootdev]
	mov ah,0x42 ; не использую ah=0x02 ибо не хочу ебаться с переводом lba в chs
	int 13h
	mov sp,di
	popa
	ret
	
;calculatesect
;ВХОД: ax=номер кластера
;ВЫХОД: ax=LBA
calculatesect:
	push bx
	push dx
	sub ax,2
	mul byte [secsPerCluster]
	add ax,word [firstdatasect]
	pop dx
	pop bx
	ret

print:
	pusha
	.loop:
		lodsb
		test al,al
		jz .done
		mov ah,0eh
		int 10h
		jmp .loop
	.done:
		popa
		ret

welcome_msg: db "Kestrel FAT16 Bootloader zhzhzhzhzhz",10,13,0
boot_msg: db "Image loaded at 0x0:0x1000",10,13,0
kernel_name: db "KURICA  BIN"
times 510-($-$$) db 0
db 0x55, 0xAA